package envoy.server;

import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

import com.jenkov.nioserver.Server;

/**
 * Starts the server.<br>
 * <br>
 * Project: <strong>envoy-server-standalone</strong><br>
 * File: <strong>Startup.java</strong><br>
 * Created: <strong>24.12.2019</strong><br>
 *
 * @author Kai S. K. Engelbart
 * @since Envoy Server Standalone v0.1-alpha
 */
public class Startup {

	/**
	 * Starts the server.
	 *
	 * @param args the run configuration. Currently unused.
	 * @throws IOException if the server crashes
	 * @since Envoy Server Standalone v0.1-alpha
	 */
	public static void main(String[] args) throws IOException {
		Set<ObjectProcessor<?, ?>> processors = new HashSet<>();
		processors.add(new LoginCredentialProcessor());
		processors.add(new MessageProcessor());
		Server server = new Server(8080, () -> new ObjectMessageReader(), new ObjectMessageProcessor(processors));
		server.start();
	}
}